IF OBJECT_ID('sp_InterfazOfimatica') IS NOT NULL
	DROP PROCEDURE sp_InterfazOfimatica
GO

--sp_InterfazOfimatica 10,0,0,0,'20161201','20161215'

CREATE PROCEDURE sp_InterfazOfimatica 

 @EMP_CID VARCHAR (20)
,@SUC_CID VARCHAR (20)
,@CEN_CID VARCHAR (20)
,@CLA_CID VARCHAR (20)
,@LIT_DFECHA_INI DATETIME = NULL
,@LIT_DFECHA_FIN DATETIME = NULL
  
AS
BEGIN
SET NOCOUNT ON;	

DECLARE @FechaIni DATETIME
,@FechaFin DATETIME
SET @FechaIni = CONVERT(DATETIME,Convert(varchar(10),@LIT_DFECHA_INI, 112))
SET @FechaFin = DATEADD(HOUR,24,CONVERT(DATETIME,Convert(varchar(10),@LIT_DFECHA_FIN, 112)))

	
SELECT * FROM (
-- 1. Extras Diurnas
SELECT 	NOM_LIQ_TURNOS.IdDispositivo, NOM_LIQ_TURNOS.NombreDispositivo
    , NOM_EMPLEADO.EMP_CNUM_DOC
	, NOM_LIQ_TURNOS.LIT_DFECHA, NOM_EMPLEADO.SUC_CID AS Grupo
	,'1004' AS CONCEPTO
	, (NOM_LIQ_TURNOS.LIT_HE_D_VLR) AS VALOR
	, (NOM_LIQ_TURNOS.LIT_HE_D_CANT) AS CANTIDAD
	
FROM NOM_LIQ_TURNOS 
	INNER JOIN	NOM_EMPLEADO ON NOM_LIQ_TURNOS.EMP_CID = NOM_EMPLEADO.EMP_CID 
	INNER JOIN	NOM_TURNO ON NOM_LIQ_TURNOS.TUR_CID = NOM_TURNO.TUR_CID 
	INNER JOIN	GEN_CENCOSTO ON NOM_EMPLEADO.CEN_CID = GEN_CENCOSTO.CEN_CID

WHERE NOM_EMPLEADO.EMP_CID = CASE @EMP_CID WHEN '0' THEN NOM_EMPLEADO.EMP_CID ELSE @EMP_CID END
	AND NOM_EMPLEADO.SUC_CID = CASE @SUC_CID WHEN '0' THEN NOM_EMPLEADO.SUC_CID ELSE @SUC_CID END
	AND NOM_EMPLEADO.CEN_CID = CASE @CEN_CID WHEN '0' THEN NOM_EMPLEADO.CEN_CID ELSE @CEN_CID END
	AND NOM_EMPLEADO.CLA_CID = CASE @CLA_CID WHEN '0' THEN NOM_EMPLEADO.CLA_CID ELSE @CLA_CID END
	AND NOM_LIQ_TURNOS.LIT_DFECHA BETWEEN @FechaIni AND @FechaFin
	AND NOM_LIQ_TURNOS.LIT_HE_D_CANT <> 0                      
--GROUP BY NOM_EMPLEADO.EMP_CNUM_DOC


UNION ALL

-- 2. Extras Nocturnas
SELECT	NOM_LIQ_TURNOS.IdDispositivo, NOM_LIQ_TURNOS.NombreDispositivo
	, NOM_EMPLEADO.EMP_CNUM_DOC
	, NOM_LIQ_TURNOS.LIT_DFECHA, NOM_EMPLEADO.SUC_CID AS Grupo
	,'1005' AS CONCEPTO
	, (NOM_LIQ_TURNOS.LIT_HE_N_VLR) AS VALOR
	, (NOM_LIQ_TURNOS.LIT_HE_N_CANT) AS CANTIDAD
							
FROM NOM_LIQ_TURNOS 
	INNER JOIN	NOM_EMPLEADO ON NOM_LIQ_TURNOS.EMP_CID = NOM_EMPLEADO.EMP_CID 
	INNER JOIN	NOM_TURNO ON NOM_LIQ_TURNOS.TUR_CID = NOM_TURNO.TUR_CID 
	INNER JOIN	GEN_CENCOSTO ON NOM_EMPLEADO.CEN_CID = GEN_CENCOSTO.CEN_CID

WHERE NOM_EMPLEADO.EMP_CID = CASE @EMP_CID WHEN '0' THEN NOM_EMPLEADO.EMP_CID ELSE @EMP_CID END
	AND NOM_EMPLEADO.SUC_CID = CASE @SUC_CID WHEN '0' THEN NOM_EMPLEADO.SUC_CID ELSE @SUC_CID END
	AND NOM_EMPLEADO.CEN_CID = CASE @CEN_CID WHEN '0' THEN NOM_EMPLEADO.CEN_CID ELSE @CEN_CID END
	AND NOM_EMPLEADO.CLA_CID = CASE @CLA_CID WHEN '0' THEN NOM_EMPLEADO.CLA_CID ELSE @CLA_CID END
	AND NOM_LIQ_TURNOS.LIT_DFECHA BETWEEN @FechaIni AND @FechaFin
	AND NOM_LIQ_TURNOS.LIT_HE_N_CANT <> 0 
--GROUP BY NOM_EMPLEADO.EMP_CNUM_DOC

UNION ALL

-- 3. Extras Festivas Diurnas
SELECT	NOM_LIQ_TURNOS.IdDispositivo, NOM_LIQ_TURNOS.NombreDispositivo
	, NOM_EMPLEADO.EMP_CNUM_DOC
	, NOM_LIQ_TURNOS.LIT_DFECHA, NOM_EMPLEADO.SUC_CID AS Grupo
	,'1006' AS CONCEPTO
	, (NOM_LIQ_TURNOS.LIT_HE_F_D_VLR) AS VALOR
	, (NOM_LIQ_TURNOS.LIT_HE_F_D_CANT) AS CANTIDAD
							
FROM NOM_LIQ_TURNOS 
	INNER JOIN	NOM_EMPLEADO ON NOM_LIQ_TURNOS.EMP_CID = NOM_EMPLEADO.EMP_CID 
	INNER JOIN	NOM_TURNO ON NOM_LIQ_TURNOS.TUR_CID = NOM_TURNO.TUR_CID 
	INNER JOIN	GEN_CENCOSTO ON NOM_EMPLEADO.CEN_CID = GEN_CENCOSTO.CEN_CID

WHERE NOM_EMPLEADO.EMP_CID = CASE @EMP_CID WHEN '0' THEN NOM_EMPLEADO.EMP_CID ELSE @EMP_CID END
	AND NOM_EMPLEADO.SUC_CID = CASE @SUC_CID WHEN '0' THEN NOM_EMPLEADO.SUC_CID ELSE @SUC_CID END
	AND NOM_EMPLEADO.CEN_CID = CASE @CEN_CID WHEN '0' THEN NOM_EMPLEADO.CEN_CID ELSE @CEN_CID END
	AND NOM_EMPLEADO.CLA_CID = CASE @CLA_CID WHEN '0' THEN NOM_EMPLEADO.CLA_CID ELSE @CLA_CID END
	AND NOM_LIQ_TURNOS.LIT_DFECHA BETWEEN @FechaIni AND @FechaFin
	AND NOM_LIQ_TURNOS.LIT_HE_F_D_CANT <> 0 
--GROUP BY NOM_EMPLEADO.EMP_CNUM_DOC

UNION ALL

-- 4. Extras Festivas Nocturnas
SELECT	NOM_LIQ_TURNOS.IdDispositivo, NOM_LIQ_TURNOS.NombreDispositivo
	, NOM_EMPLEADO.EMP_CNUM_DOC
	, NOM_LIQ_TURNOS.LIT_DFECHA, NOM_EMPLEADO.SUC_CID AS Grupo
	,'1007' AS CONCEPTO
	, (NOM_LIQ_TURNOS.LIT_HE_F_N_VLR) AS VALOR
	, (NOM_LIQ_TURNOS.LIT_HE_F_N_CANT) AS CANTIDAD
							
FROM NOM_LIQ_TURNOS 
	INNER JOIN	NOM_EMPLEADO ON NOM_LIQ_TURNOS.EMP_CID = NOM_EMPLEADO.EMP_CID 
	INNER JOIN	NOM_TURNO ON NOM_LIQ_TURNOS.TUR_CID = NOM_TURNO.TUR_CID 
	INNER JOIN	GEN_CENCOSTO ON NOM_EMPLEADO.CEN_CID = GEN_CENCOSTO.CEN_CID

WHERE NOM_EMPLEADO.EMP_CID = CASE @EMP_CID WHEN '0' THEN NOM_EMPLEADO.EMP_CID ELSE @EMP_CID END
	AND NOM_EMPLEADO.SUC_CID = CASE @SUC_CID WHEN '0' THEN NOM_EMPLEADO.SUC_CID ELSE @SUC_CID END
	AND NOM_EMPLEADO.CEN_CID = CASE @CEN_CID WHEN '0' THEN NOM_EMPLEADO.CEN_CID ELSE @CEN_CID END
	AND NOM_EMPLEADO.CLA_CID = CASE @CLA_CID WHEN '0' THEN NOM_EMPLEADO.CLA_CID ELSE @CLA_CID END
	AND NOM_LIQ_TURNOS.LIT_DFECHA BETWEEN @FechaIni AND @FechaFin
	AND NOM_LIQ_TURNOS.LIT_HE_F_N_CANT <> 0 
--GROUP BY NOM_EMPLEADO.EMP_CNUM_DOC

UNION ALL

-- 5. Festivo Diurno
SELECT	NOM_LIQ_TURNOS.IdDispositivo, NOM_LIQ_TURNOS.NombreDispositivo
	, NOM_EMPLEADO.EMP_CNUM_DOC
	, NOM_LIQ_TURNOS.LIT_DFECHA, NOM_EMPLEADO.SUC_CID AS Grupo
	,'xxx' AS CONCEPTO
	, (NOM_LIQ_TURNOS.LIT_DF_D_VLR) AS VALOR
	, (NOM_LIQ_TURNOS.LIT_DF_D_CANT) AS CANTIDAD
							
FROM NOM_LIQ_TURNOS 
	INNER JOIN	NOM_EMPLEADO ON NOM_LIQ_TURNOS.EMP_CID = NOM_EMPLEADO.EMP_CID 
	INNER JOIN	NOM_TURNO ON NOM_LIQ_TURNOS.TUR_CID = NOM_TURNO.TUR_CID 
	INNER JOIN	GEN_CENCOSTO ON NOM_EMPLEADO.CEN_CID = GEN_CENCOSTO.CEN_CID

WHERE NOM_EMPLEADO.EMP_CID = CASE @EMP_CID WHEN '0' THEN NOM_EMPLEADO.EMP_CID ELSE @EMP_CID END
	AND NOM_EMPLEADO.SUC_CID = CASE @SUC_CID WHEN '0' THEN NOM_EMPLEADO.SUC_CID ELSE @SUC_CID END
	AND NOM_EMPLEADO.CEN_CID = CASE @CEN_CID WHEN '0' THEN NOM_EMPLEADO.CEN_CID ELSE @CEN_CID END
	AND NOM_EMPLEADO.CLA_CID = CASE @CLA_CID WHEN '0' THEN NOM_EMPLEADO.CLA_CID ELSE @CLA_CID END
	AND NOM_LIQ_TURNOS.LIT_DFECHA BETWEEN @FechaIni AND @FechaFin
	AND NOM_LIQ_TURNOS.LIT_DF_D_CANT <> 0
--GROUP BY NOM_EMPLEADO.EMP_CNUM_DOC

UNION ALL

-- 6. Festivo Nocturno
SELECT	NOM_LIQ_TURNOS.IdDispositivo, NOM_LIQ_TURNOS.NombreDispositivo
	, NOM_EMPLEADO.EMP_CNUM_DOC
	, NOM_LIQ_TURNOS.LIT_DFECHA, NOM_EMPLEADO.SUC_CID AS Grupo
	,'xxx' AS CONCEPTO
	, (NOM_LIQ_TURNOS.LIT_DF_N_VLR) AS VALOR
	, (NOM_LIQ_TURNOS.LIT_DF_N_CANT) AS CANTIDAD
							
FROM NOM_LIQ_TURNOS 
	INNER JOIN	NOM_EMPLEADO ON NOM_LIQ_TURNOS.EMP_CID = NOM_EMPLEADO.EMP_CID 
	INNER JOIN	NOM_TURNO ON NOM_LIQ_TURNOS.TUR_CID = NOM_TURNO.TUR_CID 
	INNER JOIN	GEN_CENCOSTO ON NOM_EMPLEADO.CEN_CID = GEN_CENCOSTO.CEN_CID

WHERE NOM_EMPLEADO.EMP_CID = CASE @EMP_CID WHEN '0' THEN NOM_EMPLEADO.EMP_CID ELSE @EMP_CID END
	AND NOM_EMPLEADO.SUC_CID = CASE @SUC_CID WHEN '0' THEN NOM_EMPLEADO.SUC_CID ELSE @SUC_CID END
	AND NOM_EMPLEADO.CEN_CID = CASE @CEN_CID WHEN '0' THEN NOM_EMPLEADO.CEN_CID ELSE @CEN_CID END
	AND NOM_EMPLEADO.CLA_CID = CASE @CLA_CID WHEN '0' THEN NOM_EMPLEADO.CLA_CID ELSE @CLA_CID END
	AND NOM_LIQ_TURNOS.LIT_DFECHA BETWEEN @FechaIni AND @FechaFin
	AND NOM_LIQ_TURNOS.LIT_DF_N_CANT <> 0
--GROUP BY NOM_EMPLEADO.EMP_CNUM_DOC

UNION ALL

-- 7. Recargos Nocturnos
SELECT	NOM_LIQ_TURNOS.IdDispositivo, NOM_LIQ_TURNOS.NombreDispositivo
	, NOM_EMPLEADO.EMP_CNUM_DOC
	, NOM_LIQ_TURNOS.LIT_DFECHA, NOM_EMPLEADO.SUC_CID AS Grupo
	,'1008' AS CONCEPTO
	, (NOM_LIQ_TURNOS.LIT_RN_VLR) AS VALOR
	, (NOM_LIQ_TURNOS.LIT_RN_CANT) AS CANTIDAD
							
FROM NOM_LIQ_TURNOS 
	INNER JOIN	NOM_EMPLEADO ON NOM_LIQ_TURNOS.EMP_CID = NOM_EMPLEADO.EMP_CID 
	INNER JOIN	NOM_TURNO ON NOM_LIQ_TURNOS.TUR_CID = NOM_TURNO.TUR_CID 
	INNER JOIN	GEN_CENCOSTO ON NOM_EMPLEADO.CEN_CID = GEN_CENCOSTO.CEN_CID

WHERE NOM_EMPLEADO.EMP_CID = CASE @EMP_CID WHEN '0' THEN NOM_EMPLEADO.EMP_CID ELSE @EMP_CID END
	AND NOM_EMPLEADO.SUC_CID = CASE @SUC_CID WHEN '0' THEN NOM_EMPLEADO.SUC_CID ELSE @SUC_CID END
	AND NOM_EMPLEADO.CEN_CID = CASE @CEN_CID WHEN '0' THEN NOM_EMPLEADO.CEN_CID ELSE @CEN_CID END
	AND NOM_EMPLEADO.CLA_CID = CASE @CLA_CID WHEN '0' THEN NOM_EMPLEADO.CLA_CID ELSE @CLA_CID END
	AND NOM_LIQ_TURNOS.LIT_DFECHA BETWEEN @FechaIni AND @FechaFin
	AND NOM_LIQ_TURNOS.LIT_RN_CANT <> 0
--GROUP BY NOM_EMPLEADO.EMP_CNUM_DOC
 
) tbTotal
ORDER BY tbTotal.EMP_CNUM_DOC,tbTotal.LIT_DFECHA
                     
END                  
        